DROP TABLE IF EXISTS results;
DROP TABLE IF EXISTS xy;
DROP TABLE IF EXISTS buildings;

CREATE TABLE buildings (
	gid serial PRIMARY KEY,
	name varchar(10)
);
SELECT AddGeometryColumn('','buildings','geom','4326','MULTIPOLYGON',2);

CREATE TABLE xy (
	point_name varchar(14) PRIMARY KEY
);
SELECT AddGeometryColumn('','xy','geom','4326','POINT',2);

CREATE TABLE results (
	point_name varchar(14) REFERENCES xy(point_name),
	date date NOT NULL,
	move smallint
	PRIMARY KEY (point_name, date)
);

CREATE INDEX date_indx ON results(date);
CREATE INDEX name_indx ON results(point_name);
