<?php
/* *****************************************************************************
 *  Ulyses - an open source project to drive total stations and
 *          publish observation results
 *  GPL v2.0 license
 *  Copyright (C) 2010-2012 Zoltan Siki <siki@agt.bme.hu>
 *                          Szonja Zemko
 *  Original version: Szonja Zemko
 *  Multilingual version: Zoltan Siki
 *  jQuery version: Zoltan Siki
 *******************************************************************************
 *  Demo page width Google Maps
 *	Optional query string parameters:
 *		lang - interface language en/hu, default en
 *		width - map width pixels, default 500
 *		height - map height pixels, default 500
 *******************************************************************************
 */
// load configuration & defaults
include_once("config.php");

// language for user interface
if (isset($_REQUEST["lang"])) {
	$i = array_search($_REQUEST["lang"], $langs);
	if ($i) {
		$lang = $_REQUEST["lang"];
		if (count($languages) <= $i) {
			$i = 0;
		}
		$xlang = $languages[$i];
	}
}
if (! isset($lang)) {
	$lang="en";
	$xlang="hu";
}
if (! isset($xlang)) {
	if ($lang == "en") {
		$xlang = "hu";
	} else {
		$xlang = "en";
	}
}

include_once("msg_" . $lang . ".php");

// set map widget size
if (isset($_REQUEST["width"])) {
	$width = $_REQUEST["width"];
}
if (! isset($width)) {
	$width = 500;
}

if (isset($_REQUEST["height"])) {
	$height = $_REQUEST["height"];
}
if (! isset($height)) {
	$height = 500;
}

?>

<html>
<head>
<!-- for cell phone -->
<meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>

<title><?php echo $msg["title"];?></title>

<!-- locale java messages -->
<script type="text/javascript">
var js_msg = new Array();
var js_key = new Array();
<?php
$i = 0;
foreach ($js_msg as $key => $value) {
	echo "js_key[" . $i . "] = '" . $key . "';\n";
	echo "js_msg[" . $i . "] = '" . $value . "';\n";
	$i++;
}
echo "ulyxesHost = '$host';";
?>

function getMsg(key) {
	var i = 0;
	var k = -1;
	for (i = 0; i < js_key.length; i++) {
		if (js_key[i] == key) k = i;
	}
	if (k < 0) return "Missing string!";
	return js_msg[k];
}
</script>
<!-- google maps api -->
<script language="javascript" type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
<!-- jQuery -->
<?php
echo '<link rel="stylesheet" type="text/css" href="http://' . $host + '/jquery_ui/css/ui-lightness/jquery-ui-1.8.22.custom.css">';
echo '<script language="javascript" type="text/javascript" src="http://' . $host . '/jquery_ui/js/jquery-1.7.2.min.js"></script>';
echo '<script language="javascript" type="text/javascript" src="http://' . $host . '/jquery_ui/js/jquery-ui-1.8.22.custom.min.js"></script>';
echo '<script language="javascript" type="text/javascript" src="http://' . $host . '/jquery_ui/flot/jquery.flot.min.js"></script>';
?>

<script type="text/javascript">

/* color array for points and graphs */
var cols = ["blue", "red", "green", "yellow"];
var hexcols = ["0000ff", "ff0000", "259225", "ffff4d"];
var icons = ["blue_MarkerA.png", "red_MarkerK.png", "darkgreen_MarkerF.png", "yellow_MarkerB.png"];
var bgcol = '#fbfad6';  // background color for form

<?php
    if ($lang == "hu") {
        echo "dateReg = /^20[0-9]{2}-[0-1][0-9]-[0-3][0-9]$/;";
        echo "dFormat = 'yy-mm-dd';";
        echo "pgFormat = 'yyyy-mm-dd';";
    } else {
        echo "dateReg = /^[0-1][0-9]\/[0-3][0-9]\/20[0-9]{2}$/;";
        echo "dFormat = 'mm/dd/yy';";
        echo "pgFormat = 'mm/dd/yyyy';";
    }
?>

/* remove leading and ending "c" characters from string */
String.prototype.trim = function (c) {
	var r = new RegExp("^"+c+"+|"+c+"+$");
	return this.replace(r, "");
}

function chg() {
    var u = "<?php echo $_SERVER['PHP_SELF']; ?>";
    var s = $("#size").val().split(",");
    window.location = u + "?lang=" + $("#lang").val() +
        '&width=' + s[0] + '&height=' + s[1];
}

/* generate random hexa color */
function get_random_color() {
	var letters = '0123456789ABCDEF'.split('');
	var color = '';
	for (var i = 0; i < 6; i++ ) {
		color += letters[Math.round(Math.random() * 15)];
	}
	return color;
}

/* check date validity */
function dateCheck(date) {
	var r = new RegExp('^20[0-9]{2}-[0-1][0-9]-[0-3][0-9]$');

	if (! r.test(date)) { //date format check
		alert (getMsg('invaliddate') + date);
		return false;
	}
	return true
}

function GetPoints() { //requesting the target points
	$.ajax({
	url: "getdata.php",
	data: { type: "points" }
	}).done(function(data) {
		var pts = eval("(" + data + ")"); //json string to object
		var shadow = new google.maps.MarkerImage('marker-shadow.png',
			new google.maps.Size(37, 32),
			new google.maps.Point(10,0),
			new google.maps.Point(0,32));	
		// remove previous points from list
		$("#pn").find("option").remove();
		for (var i = 0 ; i < pts.xy.length ; i++) {
			$("#pn").append($("<option />", {
				value: pts.xy[i].point_name,
				text: pts.xy[i].point_name
			}).css("color", cols[i % cols.length]));
			// add marker
			var latlng = new google.maps.LatLng(parseFloat(pts.xy[i].lat),
				parseFloat(pts.xy[i].lng));
			var marker = new google.maps.Marker({
				position: latlng,
				map: map,
				shadow: shadow,
				title: pts.xy[i].point_name,
				icon: icons[i % icons.length]
			});
			// add info window
			attachInfo(marker, pts.xy[i].point_name);
		}
	})
}

function attachInfo (marker, txt) {
	var wstr = "<b>" + txt + "</b><br>" + getMsg('demodata') + "<br>";
	// fill info window
	wstr += "<a href='" + txt + ".jpg' target='_blank'><img src='" + txt + ".jpg' height=100></a>";
	var infowindow = new google.maps.InfoWindow({
		content: wstr,
		position: marker.getPosition()
	});
	google.maps.event.addListener(marker, 'click', function() {
		infowindow.open(map, marker);

		// Select clicked point in point list
		$("#pn").find('option:[value='+txt+']').attr('selected', true);
	});
}

/* get polygons from server to draw */
function GetBuildings() {
	// get building data
	$.ajax({
	url: "getdata.php",
	data: { type: "buildings" }
	}).done(function(data) {
		var bdgs = eval("(" + data + ")");
		// add buildings to map
		for (var j=0 ; j < bdgs.buildings.length ; j++) {
			var bCoords = new Array();
			for (var i=0 ; i < bdgs.buildings[j].points.length ; i++) {
				bCoords[i] = new google.maps.LatLng(
					parseFloat(bdgs.buildings[j].points[i].lat),
					parseFloat(bdgs.buildings[j].points[i].lng));
			}
			var building = new google.maps.Polygon({
				paths: bCoords,
				strokeColor: "#FF0000",
				strokeOpacity: 0.8,
				strokeWeight: 2,
				fillColor: "#FF0000",
				fillOpacity: 0.35
			});
			building.setMap(map);
		}
	})
}

/* get tabular data form database */
function GetTable() { //request for the results
	// collect selected points
	var ptname = "";
	$("#pn option:selected").each(function() {
		ptname += $(this).text() + ",";
	});
	ptname = ptname.trim(",");

	if (ptname.length == 0) {
		//point name check
		alert (getMsg('nopoint'));
		return;
	}
	var inData = {
		type: "survey",
		point_names : ptname,
		start_date: $("#sd").val(),
		end_date: $("#ed").val()
	}
	$.ajax({
		url: "getdata.php",
		data: inData
	}).done(function(data) {
		var m;
		var tabla = eval ("(" + data + ")");
		if ($("#tab").attr('checked')) {
			// add table
			var p = "<table id='t1' border='1'><tr><th></th>";
			for (var j=0 ; j < tabla.survey.length ; j++) {
				p += "<th>" + tabla.survey[j].point_name + "</th>";
			}
			p += "</tr><center>";

			for (var i=0 ; i < tabla.survey[0].data.length ; i++) {
				p += "<tr><td>" + tabla.survey[0].data[i].dt + "</td>";
				for (var j=0 ; j < tabla.survey.length ; j++) {
					try {
						m = tabla.survey[j].data[i].movement;
					} catch (err) {
						m = "NULL";
					}
					p += "<td>" + m + "</td>";
				}
				p += "</tr></center>";
			}
			p += "</table>";
			$("#tbl").html(p);
			$("#t1 tr:odd").css("background-color", bgcol);
		} else if ($("#cgra").attr("checked")) {
			// chart using owtchart
			var p = "http://" + ulyxesHost + "/cgi-bin/owtchart?Type=Line&W=500&H=300&NumSets=" +
			tabla.survey.length + "&NumPts=" +
			tabla.survey[0].data.length + "&";
			// legend for linegraphs

			var v = "Vals=";
			var l = "XLabels=";
			var last = 0;
			for (var j=0 ; j < tabla.survey.length ; j++) {
				for (var i=0 ; i < tabla.survey[0].data.length ; i++) {
					if (j == 0) {
						l += tabla.survey[0].data[i].dt + ";";
					}
					try {
						last = tabla.survey[j].data[i].movement;
					} catch(err) { }
					v += last + "!";
				}
			}
			p += v.trim("!") + "&" + l.trim(";");

			var c = "&SetColors=";
			// assign colors to linegraphs
			for (i=0 ; i < tabla.survey.length ; i++) {
				c += hexcols[i % cols.length] + "!";
			}
			c = c.trim("!");
			p += c;

			var leg = "";
			for (var l=0 ; l < tabla.survey.length ; l++) {
				leg += "<font size='2' color=" + cols[l % cols.length] + ">" + tabla.survey[l].point_name + "</font>, ";
			}
			leg = leg.trim(', ');

			$("#tbl").html("<b>" + leg + "</b><br><img src='" + p + "'>");
		} else if ($("#jgra").attr("checked")) {
			// assign color to linegraphs
			var leg = "";
			for (var l=0 ; l < tabla.survey.length ; l++) {
				leg += "<font size='2' color=" + cols[l % cols.length] + ">"
					+ tabla.survey[l].point_name + "</font>, ";
			}
			leg = leg.trim(', ');

			$("#tbl").html("<b>" + leg + "</b><br><img src='" + g + "'>");

			var p = "";
			for (var j=0 ; j < tabla.survey.length ; j++) {
				for (var i=0 ; i < tabla.survey[j].data.length ; i++) {
					p += tabla.survey[j].data[i].dt + "," +
						tabla.survey[j].data[i].movement + "\n";
				}
				var g = new Dygraph(
					$("#tbl"),
					getMsg('datemovement') + p,
					{
						//rollPeriod: 14,
						colors: [clr],
						title: leg,
						ylabel: getMsg('movement')
					}
				);
			}
		}
	})
}

/* show the map */
$(document).ready(function() {
	$("#sd").datepicker( {dateFormat: dFormat, defaultDate: "-30"} );
	$("#ed").datepicker( {dateFormat: dFormat} );
	$("#t0").css("background-color", bgcol);
	$("#lang").change(function(e) { chg(); });
	$("#size").change(function(e) { chg(); });

	myLatlng = new google.maps.LatLng(47.4814139,19.055533);
	zoomLevel = 18;
	var myOptions = {
		zoom: zoomLevel,
		center: myLatlng,
		streetViewControl: false,
		rotateControl: false,
		mapTypeId: google.maps.MapTypeId.ROADMAP
	}
	map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
	map.setTilt(0);
	
	// draw building
	GetBuildings();
	// draw point markers
	GetPoints();
});

/* reset zoom and scale */
function startZoom() {
	map.setCenter(myLatlng);
	map.setZoom(zoomLevel);
}

/* clear table/chart area and reset form */
function ClearTable() {
	$("#tbl").html('');
	document.getElementById("queryform").reset();
}
</script>
</head>
<body>
<table border="0">
	<tr><td rowspan="3" valign="top">
<?php echo "<div id=\"map_canvas\" style=\"width:" . $width . "px; height:" . $height . "px\"></div>"; ?>
	</td>
	<td valign="top">
	<form name="queryform" id="queryform">
	<h3><?php echo $msg["demodata"]; ?> &nbsp;
	<select id="lang">
	<?php
		for ($i=0; $i < count($langs); $i++) {
			if ($lang == $langs[$i]) {
				echo "<option value=\"" . $langs[$i] .
					"\" selected=\"selected\">" .
					$languages[$i] . "</option>";
			} else {
				echo "<option value=\"" . $langs[$i] . "\">" .
					$languages[$i] . "</option>";
			}
		}
	?>
	</select>
	<select id="size">
	<?php
		for ($i=0; $i < count($widths); $i++) {
			if ($width == $widths[$i] && $height == $heights[$i]) {
				echo "<option value=\"" .
					$widths[$i] . "," . $heights[$i] .
					"\" selected=\"selected\">" .
					$widths[$i] . " x " . $heights[$i] . "</option>";
			} else {
				echo "<option value=\"" .
					$widths[$i] . "," . $heights[$i] . "\">" .
					$widths[$i] . " x " . $heights[$i] . "</option>";
			}
		}
	?>
	</select>
	</h3>
		<table border='1' id='t0' cellpadding='3'>
			<tr><td><b><?php echo $msg["startdate"]; ?></b></td>
			<td><input type="text" id="sd" name="sd" size="12" value="2012-07-11" datepicker="true" datepicker_format="YYYY-MM-DD"></td>
			<td rowspan='3'><center><b><?php echo $msg["querytype"]; ?></b></center><br>
			<p align="left">
			<input type="radio" name="rad" id="tab" value="tab" checked><?php echo $msg["tabular"]; ?><br>
			<input type="radio" name="rad" id="cgra" value="cgra"><?php echo $msg["chart1"]; ?><br>
<!--
			<input type="radio" name="rad" id="jgra" value="jgra"><?php echo $msg["chart2"]; ?><br>
			<input type="checkbox" name="check" id="check" disabled="true" value="ker" onClick="disable()">Kereszt-korrelci<br>
-->
			</p><center>
			<?php echo "<input type=\"button\" id=\"but\" value=\"" .
			$msg["submit"] . "\" onClick=\"GetTable()\">";
			?>
			<hr>
			<?php echo "<input type=\"button\" id=\"res\" value=\"" .
			$msg["reset"] . "\" onClick=\"ClearTable()\">";
			?>
			<br>
			<?php echo "<input type=\"button\" value=\"" .
			$msg["initial"] . "\" onClick=\"startZoom()\">";
			?>
	</td></tr>
	<tr><td><b><?php echo $msg["enddate"]; ?></b></td>
			<td><input type="text" id="ed" name="ed" size="12" value="2012-08-09" datepicker="true" datepicker_format="YYYY-MM-DD"></td></tr>
		<tr><td><b><?php echo $msg["pointname"]; ?></b></td>
			<td><select name="pn" id="pn" multiple size="5"></select></td>
		</tr>
</table>
	</form>
</td></tr>
	<tr><td valign="top"><div id="tbl"></div>
	</td></tr>
	</table>
</body>
</html>
